/*
 * Code due in major part to Real's Java How-to on file transfers
 * www.rgagnon.com/javadetails/java-0542.html
 */

import java.net.*;
import java.io.*;

public class SimpleServer {
    public static void main(String[] args) {
	int filesize = 6000000; //filesize temporary hardcoded
	int bytesRead;
	int current = 0;
	byte[] mybytearray = new byte[filesize];

	System.err.println("Starting the program!");
	try {
	    ServerSocket theServer = new ServerSocket(8800);

	    while (true) {
		Socket theConnection = theServer.accept();
		
		System.err.println("Connection accepted.");
		
		//receive the file
		InputStream is = theConnection.getInputStream();
		BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream("cameraimage.jpg"));
		current = 0;

		while(is.available() <= 0) {
		    System.err.println("Waiting...");
		}
		
		// wait for end of JPEG file
		do {
		    bytesRead = is.read(mybytearray, current,
					(mybytearray.length-current));
		    if (bytesRead >= 0) current += bytesRead;
		    System.err.println("current: " + current);

		} while (!(mybytearray[current - 1] == 0xFFFFFFD9));
		
		if (!theConnection.isClosed()) {
		    System.out.println("I'm open after read.");
		}
		
		bos.write(mybytearray, 0, current);
		bos.close();
		
		//run it through matlab
		Process p = Runtime.getRuntime().exec("matlab < start");
		
		//tell us about the run through matlab
		BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));
		BufferedReader stdError = new BufferedReader(new InputStreamReader(p.getErrorStream()));
		String output = "", error = "", s;
		
		System.out.println("\nHere is the standard output of the command:\n");
		while ((s = stdInput.readLine()) != null) {
		    output += s + "\n";
		    System.out.println(s);
		}
		
		System.out.println("\nHere is the standard error of the command:\n");
		while ((s = stdError.readLine()) != null) {
		    error += s + "\n";
		    System.out.println(s);
		}

		//run it through tesseract
		p = Runtime.getRuntime().exec("./run_tesseract cameraimage_processed_rotated_nofuzz .tif");
		
		//tell us about the run through tesseract
		stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));
		stdError = new BufferedReader(new InputStreamReader(p.getErrorStream()));

		System.out.println("\nHere is the standard output of the command:\n");
		while ((s = stdInput.readLine()) != null) {
		    output += s + "\n";
		    System.out.println(s);
		}

		System.out.println("\nHere is the standard error of the command:\n");
		while ((s = stdError.readLine()) != null) {
		    error += s + "\n";
		    System.out.println(s);
		}
		
		//send back the translation - long filename right now
		BufferedReader textReader = new BufferedReader(new InputStreamReader(new FileInputStream("cameraimage_processed_rotated_nofuzz_text.txt")));
		PrintStream ps = new PrintStream(theConnection.getOutputStream());
		String textLine;
		while((textLine = textReader.readLine()) != null) {
		    ps.println(textLine);
		    System.out.println(textLine);
		}
		
		ps.flush();
				
		System.out.println("All done.");
	    }
	}
	catch (IOException e) {
	    System.err.println(e);
	}
    }
}
